/***************************************************************/
/*                                                             */
/*           PI calculator 2 (by Machin algorithm)             */
/*                                                             */
/*             I        x^(2n+1)           I        x^(2n+1)   */
/* PI = 16 * ( E (-1)^n -------- ) - 4 * ( E (-1)^n -------- ) */
/*            n=0         2n+1            n=0         2n+1     */
/*                                                             */
/***************************************************************/

#include <stdio.h>
#include <math.h>
#include <malloc.h>

void main(int argn, char* args[])
{

unsigned char * b;
unsigned char * bb;
unsigned char * bbb;
unsigned char * bd;
unsigned char * b1;
unsigned char * b6;
unsigned char * b16;
unsigned char * c;
unsigned char * cc;
unsigned char * ccc;
unsigned char * cd;
unsigned char * c4;
unsigned char * d1;
unsigned char * d2;
unsigned char * d3;
unsigned char * dd;
unsigned char * e;
unsigned char * p;

signed long a,
            bt,
            bt1,
            bt2,
            bt3,
            bt4,
            bt5,
            bt6,
            bt7,
            bt8,
            bt9,
            ct,
            ct1,
            ct2,
            ct3,
            dt,
            dt0,
            dt1,
            dt2,
            ddt,
            et0,
            et1,
            et2,
            pt1,
            pt2;

unsigned long btr1,
              ctr1,
              dti,
              dtr1,
              etr,
              n,
              m,
              S,
              i;

signed long r;

printf("PI calculator 2 (by Machin algorithm) V.4.\n");


S=0;
i=0;
while(*(args[1]+i)!=0)
{
S=S*10+*(args[1]+i)-48;
i++;
}

if (S==0){
printf("Run: PI24 [number] (more number - more precision and more time)\n",m);
return;
}

S+=5;

m=(S+1)*18;

b = (unsigned char*) malloc(m);
if (b==NULL) {printf("Not enough memory (%d bytes).\n",m);return;}

bb=b+S+1;
bbb=b+(S+1)*2;
bd=b+(S+1)*3;
b1=b+(S+1)*4;
b6=b+(S+1)*5;
b16=b+(S+1)*6;
c=b+(S+1)*7;
cc=b+(S+1)*8;
ccc=b+(S+1)*9;
cd=b+(S+1)*10;
c4=b+(S+1)*11;
d1=b+(S+1)*12;
d2=b+(S+1)*13;
d3=b+(S+1)*14;
dd=b+(S+1)*15;
e=b+(S+1)*16;
p=b+(S+1)*17;

a=1;
n=2;

printf("Calculating %d digits of PI (last digit rounded)...\n",S-5);

printf("PI(0)=3");
printf("\n");

for(r=0;r<S;r++){
b[r]=0;
bb[r]=0;
bbb[r]=0;
bd[r]=0;
b1[r]=0;
b6[r]=0;
b16[r]=0;
c[r]=0;
cc[r]=0;
ccc[r]=0;
cd[r]=0;
c4[r]=0;
d1[r]=0;
d2[r]=0;
d3[r]=0;
dd[r]=0;
e[r]=0;
p[r]=0;
}

r=1;

b[r]=2;
bb[r]=2;

r++;

while(r<S){

r++;
if (r==S) break;
c[r]=4;
cc[r]=4;

r++;
if (r==S) break;
c[r]=1;
cc[r]=1;

r++;
if (r==S) break;
c[r]=8;
cc[r]=8;

r++;
if (r==S) break;
c[r]=4;
cc[r]=4;

r++;
if (r==S) break;
c[r]=1;
cc[r]=1;

r++;
if (r==S) break;

r++;
}

// start ********************************************************

r=S-1;
d1[r]=1;
d2[r]=1;

while(1){

// d1 / d2 *********************************

dti=1;
for(r=0;r<S;r++) dd[r]=0;

while(1){

// d1 - d2 *********************************

dt0=0;
dt2=0;
r=S-1;
while(r>-1){

dt1=d1[r]-d2[r]-dt2;
if (dt1<0){
dt1=dt1+10;
dt2=1;
}else{
dt2=0;
}

if (dt1>0){
dt0=1;
}
d3[r]=dt1;

r--;
}

if (dt2==0){
// if ended without carry
r=-1+dti;
dd[r]=dd[r]+1;
if (dt0==0){
// if ended without carry and without remain
break;
}else{
// if ended without carry and with remain
r=0;
while(r<S){
d1[r]=d3[r];
dt2=dt1;
r++;
}
continue;
}
}

// if ended with carry and with remain
dti=dti+1;
if (dti>S){
break;
}

dt2=0;
r=S-1;
while(r>-1){
dt1=d1[r];
d1[r]=dt2;
dt2=dt1;
r--;
}

}

for(r=0;r<S;r++) d1[r]=0;
r=S-1;
d1[r]=1;

// b * d ***********************************

r=S-1;
while(r>-1){

dtr1=r+1;
ddt=dd[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=bb[r]*ddt+bt2+bd[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
bd[r]=bt3;
r--;
}

if (dtr1>1){
bt2=0;
r=0;
while(r<S){
bt1=bd[r];
bd[r]=bt2;
bt2=bt1;
r++;
}
}

r=-1+dtr1;
r--;
}

// b * 6 ****************************************

bt2=0;
r=S-1;
while(r>-1){

bt1=bd[r]*6+bt2;
bt2=(bt1/10);
bt3=bt1-bt2*10;
b6[r]=bt3;

r--;
}

// b * 1 *****************************************

bt5=0;
r=S-1;
while(r+1>1){
bt4=bd[r]*1+bt5;
bt5=(bt4/10);
bt6=bt4-bt5*10;
r--;
b1[r]=bt6;
}

// b * 16 ****************************************

bt8=0;
r=S-1;
while(r>-1){
bt7=b1[r]+b6[r]+bt8;
bt8=(bt7/10);
bt9=bt7-bt8*10;
b16[r]=bt9;

r--;
}

// c * d ***********************************

r=S-1;
while(r>-1){

dtr1=r+1;
ddt=dd[r];
ct2=0;
r=S-1;
while(r>-1){
ct1=cc[r]*ddt+ct2+cd[r];
ct2=(ct1/10);
ct3=ct1-ct2*10;
cd[r]=ct3;
r--;
}

if (dtr1>1){
ct2=0;
r=0;
while(r<S){
ct1=cd[r];
cd[r]=ct2;
ct2=ct1;
r++;
}
}

r=-1+dtr1;
r--;
}

// c * 4 *********************************

ct2=0;
r=S-1;
while(r>-1){

ct1=cd[r]*4+ct2;
ct2=(ct1/10);
ct3=ct1-ct2*10;

c4[r]=ct3;

r--;
}

// b - c *****************************************************

et0=0;
r=S-1;
while(r>-1){

et1=b16[r]-c4[r]-et0;
if (et1<0){
et1=et1+10;
et0=1;
}else{
et0=0;
}

e[r]=et1;

r--;
}

etr=0;
r=0;
while(r<S){
if ((e[r]>0)&&(etr==0)){
etr=r+1;
}
r++;
}

pt2=0;

if (a==1){

r=S-1;
while(r>-1){
pt1=p[r]+e[r]+pt2;
if (pt1>9){
pt1=pt1-10;
pt2=1;
}else{
pt2=0;
}
p[r]=pt1;
r--;
}

}else{

r=S-1;
while(r>-1){
pt1=p[r]-e[r]-pt2;
if (pt1<0){
pt1=pt1+10;
pt2=1;
}else{
pt2=0;
}
p[r]=pt1;
r--;
}

}

if (etr>n){
while(n<etr){
r=-1+n;
if (n<S-3){
if (n<S-4){
printf("PI(%d)=",n-1);
printf("%d",p[r]);
printf("\n");
}else{
if (p[r+1]<5){
printf("PI(%d)=",n-1);
printf("%d",p[r]);
printf("\n");
}else{
printf("PI(%d)=",n-1);
printf("%d",p[r]+1);
printf("\n");
}
}
}
n=n+1;
}
}

if (etr==0){
while(n<=S){
r=-1+n;
if (n<S-3){
if (n<S-4){
printf("PI(%d)=",n-1);
printf("%d",p[r]);
printf("\n");
}else{
if (p[r+1]<5){
printf("PI(%d)=",n-1);
printf("%d",p[r]);
printf("\n");
}else{
printf("PI(%d)=",n-1);
printf("%d",p[r]+1);
printf("\n");
}
}
}
n=n+1;
}
break;
}

for(r=0;r<S;r++) bd[r]=0;
for(r=0;r<S;r++) cd[r]=0;

// b * b 1 ******************************

r=S-1;
while(r>-1){

btr1=r+1;
bt=b[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=bb[r]*bt+bt2+bbb[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
bbb[r]=bt3;
r--;
}

if (btr1>1){
bt2=0;
r=0;
while(r<S){
bt1=bbb[r];
bbb[r]=bt2;
bt2=bt1;
r++;
}
}

r=-1+btr1;
r--;
}

r=0;
while(r<S){
bb[r]=bbb[r];
r++;
}

for(r=0;r<S;r++) bbb[r]=0;

// b * b 2 *********************************

r=S-1;
while(r>-1){

btr1=r+1;
bt=b[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=bb[r]*bt+bt2+bbb[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
bbb[r]=bt3;
r--;
}

if (btr1>1){
bt2=0;
r=0;
while(r<S){
bt1=bbb[r];
bbb[r]=bt2;
bt2=bt1;
r++;
}
}

r=-1+btr1;
r--;
}

r=0;
while(r<S){
bb[r]=bbb[r];
r++;
}

for(r=0;r<S;r++) bbb[r]=0;

// c * c 1 *********************************

r=S-1;
while(r>-1){

ctr1=r+1;
ct=c[r];
ct2=0;
r=S-1;
while(r>-1){
ct1=cc[r]*ct+ct2+ccc[r];
ct2=(ct1/10);
ct3=ct1-ct2*10;
ccc[r]=ct3;
r--;
}

if (ctr1>1){
ct2=0;
r=0;
while(r<S){
ct1=ccc[r];
ccc[r]=ct2;
ct2=ct1;
r++;
}
}

r=-1+ctr1;
r--;
}

r=0;
while(r<S){
cc[r]=ccc[r];
r++;
}

for(r=0;r<S;r++) ccc[r]=0;

// c * c 2 *********************************

r=S-1;
while(r>-1){

ctr1=r+1;
ct=c[r];
ct2=0;
r=S-1;
while(r>-1){
ct1=cc[r]*ct+ct2+ccc[r];
ct2=(ct1/10);
ct3=ct1-ct2*10;
ccc[r]=ct3;
r--;
}

if (ctr1>1){
ct2=0;
r=0;
while(r<S){
ct1=ccc[r];
ccc[r]=ct2;
ct2=ct1;
r++;
}
}

r=-1+ctr1;
r--;
}

r=0;
while(r<S){
cc[r]=ccc[r];
r++;
}

for(r=0;r<S;r++) ccc[r]=0;

// d + 1 + 1 ****************************

r=S-1;
dt=d2[r]+1;
while(r>-1){
dt=dt+1;
if (dt<10){
d2[r]=dt;
break;
}
d2[r]=dt-10;
r--;
dt=d2[r];
}

a=0-a;

}

printf("\nPI=3.");
for(r=1;r<S-5;r++) printf("%d",p[r]);
if (p[r+1]<5) printf("%d",p[r]);
else printf("%d",p[r]+1);
printf("\n");
return;
}

