/********************************************/
/*                                          */
/* PI calculator 3 (by Ramanujan algorithm) */
/*                                          */
/* 1              I  (4n)! (1103 + 26390n)  */
/* - = V2*2/9801  E  ---------------------  */
/* P             n=0    (n!)^4 396^(4n)     */
/*                                          */
/********************************************/

#include <stdio.h>
#include <math.h>
#include <malloc.h>

void main(int argn, char* args[])
{

unsigned char * b;
unsigned char * bb;
unsigned char * bbb;
unsigned char * bd;
unsigned char * b1;
unsigned char * b6;
unsigned char * b16;
unsigned char * c;
unsigned char * cc;
unsigned char * ccc;
unsigned char * cd;
unsigned char * c4;
unsigned char * d1;
unsigned char * d2;
unsigned char * d3;
unsigned char * dd;
unsigned char * e;
unsigned char * p;

signed long bt,
            bt1,
            bt2,
            bt3,
            bt4,
            bt5,
            bt6,
            bt7,
            bt8,
            bt9,
            ct,
            ct1,
            ct2,
            ct3,
            dt,
            dt0,
            dt1,
            dt2,
            ddt,
            et0,
            et1,
            et2,
            pt1,
            pt2;

unsigned long btr1,
              ctr1,
              dti,
              dtr1,
              etr,
              n,
              m,
              S,
              i;

signed long r;

printf("PI calculator III (by Ramanujan algorithm) Version 4.\n");

S=0;
i=0;
while(*(args[1]+i)!=0)
{
S=S*10+*(args[1]+i)-48;
i++;
}

if (S==0){
printf("Run: PI34 [number] (more number - more precision and more time)\n",m);
return;
}

S+=5;

m=(S+1)*18;

b = (unsigned char*) malloc(m);
if (b==NULL) {printf("Not enough memory (%d bytes).\n",m);return;}

bb=b+S+1;
bbb=b+(S+1)*2;
bd=b+(S+1)*3;
c=b+(S+1)*4;
cc=b+(S+1)*5;
ccc=b+(S+1)*6;
b1=b+(S+1)*7;
d1=b+(S+1)*8;
b6=b+(S+1)*9;
d2=b+(S+1)*10;
b16=b+(S+1)*11;
d3=b+(S+1)*12;
c4=b+(S+1)*13;
dd=b+(S+1)*14;
cd=b+(S+1)*15;
e=b+(S+1)*16;
p=b+(S+1)*17;

n=2;

printf("Calculating %d digits of PI (last digit not rounded)...\n",S-5);

for(r=0;r<S+1;r++){
b[r]=0;
bb[r]=0;
bbb[r]=0;
bd[r]=0;
b1[r]=0;
b6[r]=0;
b16[r]=0;
c[r]=0;
cc[r]=0;
ccc[r]=0;
cd[r]=0;
c4[r]=0;
d1[r]=0;
d2[r]=0;
d3[r]=0;
dd[r]=0;
e[r]=0;
p[r]=0;
}

// start 1 ********************************************************
// start 1 ********************************************************
// start 1 ********************************************************

r=S-1;
d2[r]=1;

while(1){

for(r=0;r<S+S;r++){
dd[r]=0;
d1[r]=0;
}

r=S-1;
d1[r]=2;

// dd=2/a *********************************

dti=1;
while(1){
// d1 - d2 *********************************
dt0=0;
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r]-d2[r]-dt2;
if (dt1<0){
dt1=dt1+10;
dt2=1;
}else{
dt2=0;
}
if (dt1>0){
dt0=1;
}
d3[r]=dt1;
r--;
}
if (dt2==0){
// if ended without carry
r=-1+dti;
dd[r]=dd[r]+1;
if (dt0==0){
// if ended without carry and without remain
break;
}else{
// if ended without carry and with remain
r=0;
while(r<S+S){
d1[r]=d3[r];
dt2=dt1;
r++;
}
continue;
}
}
// if ended with carry and with remain
dti=dti+1;
if (dti>S){
break;
}
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r];
d1[r]=dt2;
dt2=dt1;
r--;
}
}

// d1=a+2/a *********************************


dt2=0;
r=S-1;
while(r>-1){
dt1=dd[r]+d2[r+S-1]+dt2;
if (dt1>9){
dt1=dt1-10;
dt2=1;
}else{
dt2=0;
}
d1[r+S-1]=dt1;
r--;
}

for(r=0;r<S+S;r++){
dd[r]=0;
d2[r]=0;
}

r=S-1;
d2[r]=2;

// dd=(a+2/a)/2 *********************************

dti=1;

while(1){

// d1 - d2 *********************************

dt0=0;
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r]-d2[r]-dt2;
if (dt1<0){
dt1=dt1+10;
dt2=1;
}else{
dt2=0;
}
if (dt1>0){
dt0=1;
}
d3[r]=dt1;
r--;
}
if (dt2==0){
// if ended without carry
r=-1+dti;
dd[r]=dd[r]+1;
if (dt0==0){
// if ended without carry and without remain
break;
}else{
// if ended without carry and with remain
r=0;
while(r<S+S-1){
d1[r]=d3[r];
dt2=dt1;
r++;
}
continue;
}
}
// if ended with carry and with remain
dti=dti+1;
if (dti>S){
break;
}
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r];
d1[r]=dt2;
dt2=dt1;
r--;
}
}

dt2=0;
for(r=0;r<S;r++){
if (b[r]!=dd[r]){
dt2=1;
}
d2[S-1+r]=dd[r];
b[r]=dd[r];
dd[r]=0;
}

if (dt2==0){
break;
}

}

// dd=4.9005/V2 *******************************************************

for(r=0;r<S-1;r++){
d1[r]=0;
d2[r]=0;
dd[r]=0;
d1[r+S-1]=0;
d2[r+S-1]=b[r];
}


r=S-1;
dd[r]=0;
d1[r]=4;
d1[r+1]=9;
d1[r+4]=5;
d1[r+S-1]=0;

dti=1;
while(1){

// d1 - d2 *********************************

dt0=0;
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r]-d2[r]-dt2;
if (dt1<0){
dt1=dt1+10;
dt2=1;
}else{
dt2=0;
}
if (dt1>0){
dt0=1;
}
d3[r]=dt1;
r--;
}
if (dt2==0){
// if ended without carry
r=-1+dti;
dd[r]=dd[r]+1;
if (dt0==0){
// if ended without carry and without remain
break;
}else{
// if ended without carry and with remain
r=0;
while(r<S+S-1){
d1[r]=d3[r];
dt2=dt1;
r++;
}
continue;
}
}
// if ended with carry and with remain
dti=dti+1;
if (dti>S){
break;
}
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r];
d1[r]=dt2;
dt2=dt1;
r--;
}
}

// start 2 ********************************************************
// start 2 ********************************************************
// start 2 ********************************************************
// start 2 ********************************************************
// start 2 ********************************************************

// b = A1 ********************************

for(r=0;r<S+S;r++){
b1[r]=dd[r];
b[r]=0;
}

r=S-1;

// bb = FACT(A1)
bb[r]=1;

// bd = 4*A1
bd[r]=0;

// bbb = FACT(4*A1)
bbb[r]=1;

// c = 396^4 ********************************
//
// c[r-10]=2;
// c[r-9]=4;
// c[r-8]=5;
// c[r-7]=9;
// c[r-6]=1;
// c[r-5]=2;
// c[r-4]=5;
// c[r-3]=7;
// c[r-2]=8;
// c[r-1]=5;
// c[r]=6;

// c = 396^2 ********************************

c[r-5]=1;
c[r-4]=5;
c[r-3]=6;
c[r-2]=8;
c[r-1]=1;
c[r]=6;



// cc = (396^2)^A1 ********************************

r=S-1;
cc[r]=1;

printf("PI(0)=3");
printf("\n");

while(1){

// b16 = 26390*A1 ****************************************

for(r=0;r<S;r++){
b6[r]=0;
b16[r]=0;
}

r=S-1;

b6[r-4]=2;
b6[r-3]=6;
b6[r-2]=3;
b6[r-1]=9;
b6[r]=0;

r=0;
while(r<S){

dtr1=r+1;
ddt=b6[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=b[r]*ddt+bt2+b16[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
b16[r]=bt3;
r--;
}

if (dtr1<S){
bt2=0;
r=S-1;
while(r>-1){
bt1=b16[r];
b16[r]=bt2;
bt2=bt1;
r--;
}
}

r=-1+dtr1;
r++;
}

// b16 = 1103+26390*A1 ********************************

for(r=0;r<S;r++){
b6[r]=0;
}

r=S-1;

b6[r-3]=1;
b6[r-2]=1;
b6[r-1]=0;
b6[r]=3;

dt2=0;
r=S-1;
while(r>-1){
dt1=b6[r]+b16[r]+dt2;
if (dt1>9){
dt1=dt1-10;
dt2=1;
}else{
dt2=0;
}
b16[r]=dt1;
r--;
}

// b16 = FACT(4*A1) * (1103+26390*A1) ************************

for(r=0;r<S;r++){
b6[r]=b16[r];
b16[r]=0;
}

r=0;
while(r<S){

dtr1=r+1;
ddt=b6[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=bbb[r]*ddt+bt2+b16[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
b16[r]=bt3;
r--;
}

if (dtr1<S){
bt2=0;
r=S-1;
while(r>-1){
bt1=b16[r];
b16[r]=bt2;
bt2=bt1;
r--;
}
}

r=-1+dtr1;
r++;
}

// c4 = FACT(A1)^4 ***********************************

for(r=0;r<S;r++){
ccc[r]=bb[r];
c4[r]=0;
}

for(ct1=0;ct1<3;ct1++){

r=0;
while(r<S){

dtr1=r+1;
ddt=ccc[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=bb[r]*ddt+bt2+c4[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
c4[r]=bt3;
r--;
}

if (dtr1<S){
bt2=0;
r=S-1;
while(r>-1){
bt1=c4[r];
c4[r]=bt2;
bt2=bt1;
r--;
}
}

r=-1+dtr1;
r++;
}

for(r=0;r<S;r++){
ccc[r]=c4[r];
c4[r]=0;
}

}

// c4 = FACT(A1)^4 * (396^2)^A1 ***********************************

r=0;
while(r<S){

dtr1=r+1;
ddt=ccc[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=cc[r]*ddt+bt2+c4[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
c4[r]=bt3;
r--;
}

if (dtr1<S){
bt2=0;
r=S-1;
while(r>-1){
bt1=c4[r];
c4[r]=bt2;
bt2=bt1;
r--;
}
}

r=-1+dtr1;
r++;
}

// dd = b16 /1000 / c4 **************************

for(r=0;r<S+S;r++){
d1[r]=0;
}

for(r=0;r<S;r++){
d1[r+3]=b16[r];
d2[r]=c4[r];
d3[r]=0;
dd[r]=0;
}

for(r=S;r<S+S;r++){
d2[r]=0;
d3[r]=0;
}

r=S-1;
dti=1;
while(1){

// d1 - d2 *********************************

dt0=0;
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r]-d2[r]-dt2;
if (dt1<0){
dt1=dt1+10;
dt2=1;
}else{
dt2=0;
}
if (dt1>0){
dt0=1;
}
d3[r]=dt1;
r--;
}
if (dt2==0){
// if ended without carry
r=-1+dti;
dd[r]=dd[r]+1;
if (dt0==0){
// if ended without carry and without remain
break;
}else{
// if ended without carry and with remain
r=0;
while(r<S+S-1){
d1[r]=d3[r];
dt2=dt1;
r++;
}
continue;
}
}
// if ended with carry and with remain
dti=dti+1;
if (dti>S){
break;
}
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r];
d1[r]=dt2;
dt2=dt1;
r--;
}
}

// dd = b16 / cc **************************

for(r=0;r<S+S;r++){
d1[r]=0;
d2[r]=0;
}

for(r=0;r<S;r++){
d1[r+S-1]=dd[r];
d2[r]=cc[r];
dd[r]=0;
}

r=S-1;
dti=1;
while(1){

// d1 - d2 *********************************

dt0=0;
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r]-d2[r]-dt2;
if (dt1<0){
dt1=dt1+10;
dt2=1;
}else{
dt2=0;
}
if (dt1>0){
dt0=1;
}
d3[r]=dt1;
r--;
}
if (dt2==0){
// if ended without carry
r=-1+dti;
dd[r]=dd[r]+1;
if (dt0==0){
// if ended without carry and without remain
break;
}else{
// if ended without carry and with remain
r=0;
while(r<S+S-1){
d1[r]=d3[r];
dt2=dt1;
r++;
}
continue;
}
}
// if ended with carry and with remain
dti=dti+1;
if (dti>S){
break;
}
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r];
d1[r]=dt2;
dt2=dt1;
r--;
}
}

//for(i=0;i<S;i++) printf("%d",dd[i]); printf("\n");
//for(i=0;i<S;i++) printf("%d",e[i]); printf("\n");

// e = e + dd ***************************************

etr=0;
r=0;
while(r<S){
if ((dd[r]>0)&&(etr==0)){
etr=r+1;
}
r++;
}

r=S-1;

dt2=0;
r=S-1;
while(r>-1){
dt1=e[r]+dd[r]+dt2;
if (dt1>9){
dt1=dt1-10;
dt2=1;
}else{
dt2=0;
}
e[r]=dt1;
r--;
}

// dd = 1*4.9005/V2 / (b16/c4) *****************************

for(r=0;r<S;r++){
d1[r]=0;
d2[r]=0;
dd[r]=0;
}

for(r=0;r<S;r++){
d1[r+S-1]=b1[r];
d2[r+S-1]=e[r];
}

//for(i=0;i<S;i++) printf("%d",e[i]); printf("\n");

r=S-1;
dti=1;
while(1){

// d1 - d2 *********************************

dt0=0;
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r]-d2[r]-dt2;
if (dt1<0){
dt1=dt1+10;
dt2=1;
}else{
dt2=0;
}
if (dt1>0){
dt0=1;
}
d3[r]=dt1;
r--;
}
if (dt2==0){
// if ended without carry
r=-1+dti;
dd[r]=dd[r]+1;
if (dt0==0){
// if ended without carry and without remain
break;
}else{
// if ended without carry and with remain
r=0;
while(r<S+S-1){
d1[r]=d3[r];
dt2=dt1;
r++;
}
continue;
}
}
// if ended with carry and with remain
dti=dti+1;
if (dti>S){
break;
}
dt2=0;
r=S+S-2;
while(r>-1){
dt1=d1[r];
d1[r]=dt2;
dt2=dt1;
r--;
}
}

//for(i=0;i<S;i++) printf("%d",dd[i]); printf("\n");
//printf("\n");

// 8888888888888888888888888888888888888888888888888888888888888888888

if (etr>n){
while(n<etr){
r=-1+n;
if (n<S-3){
printf("PI(%d)=",n-1);
printf("%d",dd[r]);
printf("\n");
}
n=n+1;
}
}

if (etr==0){
while(n<=S){
r=-1+n;
if (n<S-3){
printf("PI(%d)=",n-1);
printf("%d",dd[r]);
printf("\n");
}
n=n+1;
}
break;
}

// 8888888888888888888888888888888888888888888888888888888888888888888

// b = b + 1 ****************************

r=S-1;
dt=b[r];
while(r>-1){
dt=dt+1;
if (dt<10){
b[r]=dt;
break;
}
b[r]=dt-10;
r--;
dt=b[r];
}

// bb (b6) = bb * b ******************************

for(r=0;r<S;r++) b6[r]=0;

r=0;
while(r<S){

btr1=r+1;
bt=b[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=bb[r]*bt+bt2+b6[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
b6[r]=bt3;
r--;
}

if (btr1<S){
bt2=0;
r=S-1;
while(r>-1){
bt1=b6[r];
b6[r]=bt2;
bt2=bt1;
r--;
}
}

r=-1+btr1;
r++;
}

r=0;
while(r<S){
bb[r]=b6[r];
r++;
}

for(i=0;i<4;i++){

// bd = bd + 1 + 1 + 1 + 1 *********************

r=S-1;
dt=bd[r];
while(r>-1){
dt=dt+1;
if (dt<10){
bd[r]=dt;
break;
}
bd[r]=dt-10;
r--;
dt=bd[r];
}

// bbb (b6) = bbb * bd * bd * bd * bd ****************

for(r=0;r<S;r++) b6[r]=0;

r=0;
while(r<S){

btr1=r+1;
bt=bd[r];
bt2=0;
r=S-1;
while(r>-1){
bt1=bbb[r]*bt+bt2+b6[r];
bt2=(bt1/10);
bt3=bt1-bt2*10;
b6[r]=bt3;
r--;
}

if (btr1<S){
bt2=0;
r=S-1;
while(r>-1){
bt1=b6[r];
b6[r]=bt2;
bt2=bt1;
r--;
}
}

r=-1+btr1;
r++;
}

r=0;
while(r<S){
bbb[r]=b6[r];
r++;
}

}

// cc = cc * c *********************************

for(r=0;r<S;r++) ccc[r]=0;

r=0;
while(r<S){

ctr1=r+1;
ct=c[r];
ct2=0;
r=S-1;
while(r>-1){
ct1=cc[r]*ct+ct2+ccc[r];
ct2=(ct1/10);
ct3=ct1-ct2*10;
ccc[r]=ct3;
r--;
}

if (ctr1<S){
ct2=0;
r=S-1;
while(r>-1){
ct1=ccc[r];
ccc[r]=ct2;
ct2=ct1;
r--;
}
}

r=-1+ctr1;
r++;
}

r=0;
while(r<S){
cc[r]=ccc[r];
r++;
}

}

printf("\nPI=3.");
for(r=1;r<S-4;r++) printf("%d",dd[r]);
printf("\n");
return;
}
